=== debian/changelog ===
darktable (3.0.1-0.1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * debian/control and rules: wrap-and-sort, plus generally fix typos, grammar,
    and formatting.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 11 Mar 2020 09:18:00 -0700

darktable (3.0.1-1.1) experimental; urgency=medium

  * update to 3.0.1
    https://github.com/darktable-org/darktable/releases/tag/release-3.0.1
  * added https://github.com/darktable-org/darktable/commit/8bceae80bd8459f4ec5929df75d6ec0471c3d26c.patch
    to fix regression in the basic adjustment module.

 -- Andreas Schneider <asn@cryptomilk.org>  Tue, 10 Mar 2020 15:31:00 -0000
